#include "defines.h"

#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>

extern external_objects extobj[NUMOBJS];

void read_raw_obj(char *filename, int id)
{
	FILE *fp;
	int i=0;
	char templine[MAXLINE_READ];
	char subobj[64];

	// Try to open and Check for error
	if((fp = fopen((char *)filename, "r")) == NULL)
	{
		printf("Debug: Opening \"%s\" ... \n", filename);
		perror("Error opening model");
		exit(1);
	}
	else
		printf("Success: Now reading model from \"%s\" ...\n", filename);

	// Find out how many vertices we have
	while(fgets(templine, MAXLINE_READ, fp))
	{
		if(templine[0] == 45 || (templine[0] < 58 && templine[0] > 47))
			i++;
	}
	// allocate memory
	i *= 3;
	printf("Debug: Now allocating memory for %d vertices ... \n", i);
	extobj[id].vx = malloc(sizeof(GLfloat)*i);
	extobj[id].vy = malloc(sizeof(GLfloat)*i);
	extobj[id].vz = malloc(sizeof(GLfloat)*i);
	
	// Reads the file per-line until fgets returns NULL, which it hopefully will
	rewind(fp);
	i=0;
	while(fgets(templine, MAXLINE_READ, fp))
	{
		// I don't like endlines, trash em
		templine[strlen(templine)-2] = 0;

		if(templine[0] == 45 || (templine[0] < 58 && templine[0] > 47))
		{
			// We have 3 vertices

			if(sscanf(templine, "%f %f %f   %f %f %f   %f %f %f",
						&extobj[id].vx[i],
						&extobj[id].vy[i],
						&extobj[id].vz[i],
						&extobj[id].vx[i+1],
						&extobj[id].vy[i+1],
						&extobj[id].vz[i+1],
						&extobj[id].vx[i+2],
						&extobj[id].vy[i+2],
						&extobj[id].vz[i+2]) < 0)
			{
				printf("Ack, error reading \"%s\" from \"%s\"\n",
						subobj, filename);
				exit(1);
			}
			else
			{
/*				printf("Debug: Three verticies from \"%s\" of \"%s\" are { %f, %f, %f }, { %f, %f, %f }, { %f, %f, %f }\n",
						subobj, filename,
						extobj[id].vx[i],
						extobj[id].vy[i],
						extobj[id].vz[i],
						extobj[id].vx[i+1],
						extobj[id].vy[i+1],
						extobj[id].vz[i+1],
						extobj[id].vx[i+2],
						extobj[id].vy[i+2],
						extobj[id].vz[i+2]);	*/

				i += 3;
			}
		}
		else
		{
			strcpy(subobj, templine);
			printf("Debug: Now processing subobject \"%s\" from \"%s\"\n",
					subobj, filename);
		}
	}
	printf("Total verticies read = %d\n", i);
	extobj[id].numvertices = i;

	fclose(fp);
}
